



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>关于CSRF</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">关于CSRF</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 21:57:51 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>CSRF介绍</h3>
<p>CSRF（Cross-site request forgery）跨站请求伪造，也被称为&ldquo;One Click Attack&rdquo;或者Session Riding，通常缩写为CSRF或者XSRF，是一种对网站的恶意利用。尽管听起来像跨站脚本攻击（<a href="https://baike.baidu.com/item/XSS" rel="external nofollow noreferrer">XSS</a>），但它与XSS非常不同，XSS利用站点内的信任用户，而CSRF则通过伪装成受信任用户的请求来利用受信任的网站。与<a href="https://baike.baidu.com/item/XSS" rel="external nofollow noreferrer">XSS</a>攻击相比，CSRF攻击往往不大流行（因此对其进行防范的资源也相当稀少）和难以防范，所以被认为比<a href="https://baike.baidu.com/item/XSS" rel="external nofollow noreferrer">XSS</a>更具危险性</p>
<h3>如何防范CSRF</h3>
<p>目前防范 CSRF 攻击主要有三种策略</p>
<ol><li>验证 HTTP Referer 字段</li>
<li>在请求地址中添加 token 并验证</li>
<li>在 HTTP 头中自定义属性并验证</li></ol>
<h4>验证 HTTP Referer 字段</h4>
<p>　　根据 HTTP 协议，在 HTTP 头中有一个字段叫 Referer，它记录了该 HTTP 请求的来源地址。在通常情况下，访问一个安全受限页面的请求来自于同一个网站，比如需要访问 http://bank.example/withdraw?account=bob&amp;amount=1000000&amp;for=Mallory，用户必须先登陆 bank.example，然后通过点击页面上的按钮来触发转账事件。这时，该转帐请求的 Referer 值就会是转账按钮所在的页面的 URL，通常是以 bank.example 域名开头的地址。而如果黑客要对银行网站实施 CSRF 攻击，他只能在他自己的网站构造请求，当用户通过黑客的网站发送请求到银行时，该请求的 Referer 是指向黑客自己的网站。因此，要防御 CSRF 攻击，银行网站只需要对于每一个转账请求验证其 Referer 值，如果是以 bank.example 开头的域名，则说明该请求是来自银行网站自己的请求，是合法的。如果 Referer 是其他网站的话，则有可能是黑客的 CSRF 攻击，拒绝该请求。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 这种方法的显而易见的好处就是简单易行，网站的普通开发人员不需要操心 CSRF 的漏洞，只需要在最后给所有安全敏感的请求统一增加一个拦截器来检查 Referer 的值就可以。特别是对于当前现有的系统，不需要改变当前系统的任何已有代码和逻辑，没有风险，非常便捷。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 然而，这种方法并非万无一失。Referer 的值是由浏览器提供的，虽然 HTTP 协议上有明确的要求，但是每个浏览器对于 Referer 的具体实现可能有差别，并不能保证浏览器自身没有安全漏洞。使用验证 Referer 值的方法，就是把安全性都依赖于第三方（即浏览器）来保障，从理论上来讲，这样并不安全。事实上，对于某些浏览器，比如 IE6 或 FF2，目前已经有一些方法可以篡改 Referer 值。如果 bank.example 网站支持 IE6 浏览器，黑客完全可以把用户浏览器的 Referer 值设为以 bank.example 域名开头的地址，这样就可以通过验证，从而进行 CSRF 攻击。<br />即便是使用最新的浏览器，黑客无法篡改 Referer 值，这种方法仍然有问题。因为 Referer 值会记录下用户的访问来源，有些用户认为这样会侵犯到他们自己的隐私权，特别是有些组织担心 Referer 值会把组织内网中的某些信息泄露到外网中。因此，用户自己可以设置浏览器使其在发送请求时不再提供 Referer。当他们正常访问银行网站时，网站会因为请求没有 Referer 值而认为是 CSRF 攻击，拒绝合法用户的访问。</p>
<h4>在请求地址中添加 token 并验证</h4>
<p>CSRF 攻击之所以能够成功，是因为黑客可以完全伪造用户的请求，该请求中所有的用户验证信息都是存在于 cookie 中，因此黑客可以在不知道这些验证信息的情况下直接利用用户自己的 cookie 来通过安全验证。要抵御 CSRF，关键在于在请求中放入黑客所不能伪造的信息，并且该信息不存在于 cookie 之中。可以在 HTTP 请求中以参数的形式加入一个随机产生的 token，并在服务器端建立一个拦截器来验证这个 token，如果请求中没有 token 或者 token 内容不正确，则认为可能是 CSRF 攻击而拒绝该请求。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 这种方法要比检查 Referer 要安全一些，token 可以在用户登陆后产生并放于 session 之中，然后在每次请求时把 token 从 session 中拿出，与请求中的 token 进行比对，但这种方法的难点在于如何把 token 以参数的形式加入请求。对于 GET 请求，token 将附在请求地址之后，这样 URL 就变成 http://url?csrftoken=tokenvalue。 而对于 POST 请求来说，要在 form 的最后加上 &lt;input type=&rdquo;hidden&rdquo; name=&rdquo;csrftoken&rdquo; value=&rdquo;tokenvalue&rdquo;/&gt;，这样就把 token 以参数的形式加入请求了。但是，在一个网站中，可以接受请求的地方非常多，要对于每一个请求都加上 token 是很麻烦的，并且很容易漏掉，通常使用的方法就是在每次页面加载时，使用 javascript 遍历整个 dom 树，对于 dom 中所有的 a 和 form 标签后加入 token。这样可以解决大部分的请求，但是对于在页面加载之后动态生成的 html 代码，这种方法就没有作用，还需要程序员在编码时手动添加 token。<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 该方法还有一个缺点是难以保证 token 本身的安全。特别是在一些论坛之类支持用户自己发表内容的网站，黑客可以在上面发布自己个人网站的地址。由于系统也会在这个地址后面加上 token，黑客可以在自己的网站上得到这个 token，并马上就可以发动 CSRF 攻击。为了避免这一点，系统可以在添加 token 的时候增加一个判断，如果这个链接是链到自己本站的，就在后面添加 token，如果是通向外网则不加。不过，即使这个 csrftoken 不以参数的形式附加在请求之中，黑客的网站也同样可以通过 Referer 来得到这个 token 值以发动 CSRF 攻击。这也是一些用户喜欢手动关闭浏览器 Referer 功能的原因。</p>
<h4>在 HTTP 头中自定义属性并验证</h4>
<p>这种方法也是使用 token 并进行验证，和上一种方法不同的是，这里并不是把 token 以参数的形式置于 HTTP 请求之中，而是把它放到 HTTP 头中自定义的属性里。通过 XMLHttpRequest 这个类，可以一次性给所有该类请求加上 csrftoken 这个 HTTP 头属性，并把 token 值放入其中。这样解决了上种方法在请求中加入 token 的不便，同时，通过 XMLHttpRequest 请求的地址不会被记录到浏览器的地址栏，也不用担心 token 会透过 Referer 泄露到其他网站中去。</p>
<h3>Django中的处理方法</h3>
<h4>在form表单中</h4>
<div>
<pre class="prettyprint linenums">&lt;form action="" method="post"&gt;<br />
    {% csrf_token %}　　# 添加一个被隐藏了的input<br />
    &lt;p&gt;用户名：&lt;input type="text" name="name"&gt;&lt;/p&gt;<br />
    &lt;p&gt;密码：&lt;input type="text" name="password"&gt;&lt;/p&gt;<br />
    &lt;input type="submit" value="登录"&gt;<br />
&lt;/form&gt;</pre>
</div>
<h4>在ajax请求中</h4>
<p>1、放在data中</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html lang="en"&gt;<br />
&lt;head&gt;<br />
    &lt;meta charset="UTF-8"&gt;<br />
    &lt;script src="/static/jquery-3.3.1.js"&gt;&lt;/script&gt;<br />
    &lt;title&gt;Title&lt;/title&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;<br />
&lt;p&gt;用户名：&lt;input type="text" name="name"&gt;&lt;/p&gt;<br />
&lt;p&gt;密码：&lt;input type="text" name="password" id="pwd"&gt;&lt;/p&gt;<br />
&lt;button class="btn"&gt;登录&lt;/button&gt;<br />
&lt;/body&gt;<br />
&lt;script&gt;<br />
    $(".btn").click(function () {<br />
        $.ajax({<br />
            url: '',<br />
            type: 'post',<br />
            data: {<br />
                'name': $('[name="name"]').val(),<br />
                'password': $("#pwd").val(),<br />
                'csrfmiddlewaretoken': $('[name="csrfmiddlewaretoken"]').val()　　// 通过属性选择器获取<br />
                // 'csrfmiddlewaretoken': '{{ csrf_token }}'    // 也可以这样获取<br />
            },<br />
            success: function (data) {<br />
                console.log(data)<br />
            }<br />
        })<br />
    })<br />
&lt;/script&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>2、放在cookie中</p>
<p>获取cookie：document.cookie，是一个字符串，可以自己用js切割，也可以用jquery的插件</p>
<p>获取cookie：$.cookie('csrftoken')</p>
<p>设置cookie：$.cookie('key','value')</p>
<div>
<pre class="prettyprint linenums">&lt;!DOCTYPE html&gt;<br />
&lt;html lang="en"&gt;<br />
&lt;head&gt;<br />
    &lt;meta charset="UTF-8"&gt;<br />
    &lt;script src="/static/jquery-3.3.1.js"&gt;&lt;/script&gt;<br />
    &lt;script src="/static/jquery.cookie.js"&gt;&lt;/script&gt;<br />
    &lt;title&gt;Title&lt;/title&gt;<br />
&lt;/head&gt;<br />
&lt;body&gt;<br />
&lt;form action="" method="post"&gt;<br />
    &lt;p&gt;用户名：&lt;input type="text" name="name"&gt;&lt;/p&gt;<br />
    &lt;p&gt;密码：&lt;input type="text" name="password" id="pwd"&gt;&lt;/p&gt;<br />
&lt;/form&gt;<br />
&lt;button class="btn"&gt;点我&lt;/button&gt;<br />
&lt;/body&gt;<br />
&lt;script&gt;<br />
    $(".btn").click(function () {<br />
        let token=$.cookie('csrftoken')<br />
        //let token='{{ csrf_token }}'<br />
        $.ajax({<br />
            url: '',<br />
            headers:{'X-CSRFToken':token},<br />
            type: 'post',<br />
            data: {<br />
                'name': $('[name="name"]').val(),<br />
                'password': $("#pwd").val(),<br />
            },<br />
            success: function (data) {<br />
                console.log(data)<br />
            }<br />
        })<br />
    })<br />
&lt;/script&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>在Django项目中要想不使用CSRF，直接注释中间件中的&nbsp;'django.middleware.csrf.CsrfViewMiddleware',</p>
<p>局部禁用或局部使用：用装饰器（在FBV中使用）</p>
<div>
<pre class="prettyprint linenums">from django.views.decorators.csrf import csrf_exempt,csrf_protect<br />
# 局部禁用（前提是全站使用）<br />
# @csrf_exempt<br />
# 局部使用（前提是全站禁用）<br />
# @csrf_protect<br />
def csrf_token(request):<br />
    if request.method=='POST':<br />
        print(request.POST)

        return HttpResponse('ok')<br />
    return render(request,'csrf_token.html')</pre>
</div>
<p>CBV中的使用</p>
<div>
<pre class="prettyprint linenums">from django.views import View<br />
from django.utils.decorators import method_decorator<br />
from django.views.decorators.csrf import csrf_exempt, csrf_protect

# 只能加在dispatch方法或者类上面<br />
@method_decorator(csrf_protect, name='dispatch')<br />
# @method_decorator(csrf_exempt, name='dispatch')<br />
class CsrfDisable(View):<br />
    # @method_decorator(csrf_protect)   # 局部使用<br />
    # @method_decorator(csrf_exempt)  # 局部禁用<br />
    def dispatch(self, request, *args, **kwargs):<br />
        response = super().dispatch(request, *args, **kwargs)<br />
        return response

    def get(self, request):<br />
        return HttpResponse('get')

    def post(self, request):<br />
        return HttpResponse('post')
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495ep3m9.html">JavaScript实现类的private、protected、public、static以及继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7kemx9.html">Unity Shader入门基础（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96op6e49.html">Iaas-cloudstack概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdm6248.html">在内部架设NuGet服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x2r5w9.html">Gson解析json数据&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jge438.html">java 数组内的最大组合数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp60r39.html">Linux源码-等待队列注释</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mgo3o8.html">01&period;QT初学--两个窗口相互切换</a>
		</li>
						<li><a href="https://www.batexi.com/a/960jkvn9.html">常用js函数开始收集~</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rzmj08.html">Beta冲刺 5</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvjm6g8.html">【BZOJ2054】疯狂的馒头（并查集）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvg10k8.html">【警告】WARN&colon; Establishing SSL connection without server&amp;&num;39&semi;s identity verification is not recommended&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllxk2xq.html">性能监控&lpar;3&rpar;&ndash;linux下的iostat命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o12rk1q.html">linux服务器系统盘坏且系统盘为软raid的修复方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e42pwj9.html">luogu2336 喵星球上的点名 &lpar;SA&plus;二分答案&plus;树状数组&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5jnodq.html">Silverlight中使用MVVM&lpar;1&rpar;--基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pvoog8.html">&lbrack;转&rsqb;连连看游戏 C&num;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pped1z9.html">java 基础类库之 SQLFun</a>
		</li>
						<li><a href="https://www.batexi.com/a/963k76n9.html">photoshop 切片工具进行切图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlegk39.html">图像的线性空间滤波matlab实现</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4z06k39.html">linux基本命令2</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj2x4y8.html">Mysql七种 JOIN 连接</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zrwej9.html">odoo Model字段的参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjoklg8.html">java UTC时间格式化</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1k3gxq.html">对于CAN ID的理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1lwpoq.html">jmeter笔记（5）--参数化--CSV Data Set Config</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp7ge79.html">MFC：编辑区 Edit 的属性及使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkvmve8.html">GWAS群体分层校正，该选用多少个PCA</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eyvgxz9.html">Java第五周学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z0l3j9.html">DirectX11 With Windows SDK--27 计算着色器：双调排序</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
